# coding: utf-8

"""
    Hydrogen Proton API

    Financial engineering module of Hydrogen Atom  # noqa: E501

    OpenAPI spec version: 1.9.2
    Contact: info@hydrogenplatform.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from proton_api.api_client import ApiClient


class UtilApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def decision_tree_result(self, decision_tree_result_request, **kwargs):  # noqa: E501
        """Decision Tree Result  # noqa: E501

        Traverse a decision tree and find the resulting leaf node  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.decision_tree_result(decision_tree_result_request, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param DecisionTreeResultRequest decision_tree_result_request: Request payload for Decision Tree Result (required)
        :return: dict(str, object)
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.decision_tree_result_with_http_info(decision_tree_result_request, **kwargs)  # noqa: E501
        else:
            (data) = self.decision_tree_result_with_http_info(decision_tree_result_request, **kwargs)  # noqa: E501
            return data

    def decision_tree_result_with_http_info(self, decision_tree_result_request, **kwargs):  # noqa: E501
        """Decision Tree Result  # noqa: E501

        Traverse a decision tree and find the resulting leaf node  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.decision_tree_result_with_http_info(decision_tree_result_request, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param DecisionTreeResultRequest decision_tree_result_request: Request payload for Decision Tree Result (required)
        :return: dict(str, object)
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['decision_tree_result_request']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method decision_tree_result" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'decision_tree_result_request' is set
        if self.api_client.client_side_validation and ('decision_tree_result_request' not in params or
                                                       params['decision_tree_result_request'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `decision_tree_result_request` when calling `decision_tree_result`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'decision_tree_result_request' in params:
            body_params = params['decision_tree_result_request']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['oauth2']  # noqa: E501

        return self.api_client.call_api(
            '/decision_tree_result', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='dict(str, object)',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def order_rebalance(self, order_rebalance_request, **kwargs):  # noqa: E501
        """Order Rebalance  # noqa: E501

        Create orders to rebalance client accounts or portfolios  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.order_rebalance(order_rebalance_request, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param OrderRebalanceRequest order_rebalance_request: Request payload for Order Rebalance (required)
        :return: dict(str, object)
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.order_rebalance_with_http_info(order_rebalance_request, **kwargs)  # noqa: E501
        else:
            (data) = self.order_rebalance_with_http_info(order_rebalance_request, **kwargs)  # noqa: E501
            return data

    def order_rebalance_with_http_info(self, order_rebalance_request, **kwargs):  # noqa: E501
        """Order Rebalance  # noqa: E501

        Create orders to rebalance client accounts or portfolios  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.order_rebalance_with_http_info(order_rebalance_request, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param OrderRebalanceRequest order_rebalance_request: Request payload for Order Rebalance (required)
        :return: dict(str, object)
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['order_rebalance_request']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method order_rebalance" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'order_rebalance_request' is set
        if self.api_client.client_side_validation and ('order_rebalance_request' not in params or
                                                       params['order_rebalance_request'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `order_rebalance_request` when calling `order_rebalance`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'order_rebalance_request' in params:
            body_params = params['order_rebalance_request']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['oauth2']  # noqa: E501

        return self.api_client.call_api(
            '/order_rebalance', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='dict(str, object)',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def performance_calculator(self, performance_calculator_request, **kwargs):  # noqa: E501
        """Performance Calculator  # noqa: E501

        Calculate performance/risk metrics for a Nucleus entity  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.performance_calculator(performance_calculator_request, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param PerformanceCalculatorRequest performance_calculator_request: Request payload for Performance Calculator (required)
        :return: dict(str, object)
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.performance_calculator_with_http_info(performance_calculator_request, **kwargs)  # noqa: E501
        else:
            (data) = self.performance_calculator_with_http_info(performance_calculator_request, **kwargs)  # noqa: E501
            return data

    def performance_calculator_with_http_info(self, performance_calculator_request, **kwargs):  # noqa: E501
        """Performance Calculator  # noqa: E501

        Calculate performance/risk metrics for a Nucleus entity  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.performance_calculator_with_http_info(performance_calculator_request, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param PerformanceCalculatorRequest performance_calculator_request: Request payload for Performance Calculator (required)
        :return: dict(str, object)
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['performance_calculator_request']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method performance_calculator" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'performance_calculator_request' is set
        if self.api_client.client_side_validation and ('performance_calculator_request' not in params or
                                                       params['performance_calculator_request'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `performance_calculator_request` when calling `performance_calculator`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'performance_calculator_request' in params:
            body_params = params['performance_calculator_request']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['oauth2']  # noqa: E501

        return self.api_client.call_api(
            '/performance_calculator', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='dict(str, object)',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
