# coding: utf-8

"""
    Hydrogen Proton API

    Financial engineering module of Hydrogen Atom  # noqa: E501

    OpenAPI spec version: 1.9.2
    Contact: info@hydrogenplatform.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from proton_api.configuration import Configuration


class RecurringTransactionAnalysisRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'currency_code': 'str',
        'client_id': 'str',
        'scope': 'str',
        'end_date': 'date',
        'account_ids': 'list[str]',
        'currency_conversion': 'str',
        'interval_deviation_threshold': 'int',
        'amount_deviation_threshold': 'float',
        'analyze_transactions': 'bool',
        'start_date': 'date',
        'flag_transactions': 'bool',
        'transaction_status_scope': 'list[str]',
        'only_cleansed': 'bool',
        'aggregation_account_ids': 'list[str]',
        'show_recurring_details': 'bool'
    }

    attribute_map = {
        'currency_code': 'currency_code',
        'client_id': 'client_id',
        'scope': 'scope',
        'end_date': 'end_date',
        'account_ids': 'account_ids',
        'currency_conversion': 'currency_conversion',
        'interval_deviation_threshold': 'interval_deviation_threshold',
        'amount_deviation_threshold': 'amount_deviation_threshold',
        'analyze_transactions': 'analyze_transactions',
        'start_date': 'start_date',
        'flag_transactions': 'flag_transactions',
        'transaction_status_scope': 'transaction_status_scope',
        'only_cleansed': 'only_cleansed',
        'aggregation_account_ids': 'aggregation_account_ids',
        'show_recurring_details': 'show_recurring_details'
    }

    def __init__(self, currency_code=None, client_id=None, scope='all', end_date=None, account_ids=None, currency_conversion=None, interval_deviation_threshold=3, amount_deviation_threshold=0.05, analyze_transactions=True, start_date=None, flag_transactions=False, transaction_status_scope=None, only_cleansed=False, aggregation_account_ids=None, show_recurring_details=False, _configuration=None):  # noqa: E501
        """RecurringTransactionAnalysisRequest - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._currency_code = None
        self._client_id = None
        self._scope = None
        self._end_date = None
        self._account_ids = None
        self._currency_conversion = None
        self._interval_deviation_threshold = None
        self._amount_deviation_threshold = None
        self._analyze_transactions = None
        self._start_date = None
        self._flag_transactions = None
        self._transaction_status_scope = None
        self._only_cleansed = None
        self._aggregation_account_ids = None
        self._show_recurring_details = None
        self.discriminator = None

        if currency_code is not None:
            self.currency_code = currency_code
        if client_id is not None:
            self.client_id = client_id
        if scope is not None:
            self.scope = scope
        if end_date is not None:
            self.end_date = end_date
        if account_ids is not None:
            self.account_ids = account_ids
        if currency_conversion is not None:
            self.currency_conversion = currency_conversion
        if interval_deviation_threshold is not None:
            self.interval_deviation_threshold = interval_deviation_threshold
        if amount_deviation_threshold is not None:
            self.amount_deviation_threshold = amount_deviation_threshold
        if analyze_transactions is not None:
            self.analyze_transactions = analyze_transactions
        if start_date is not None:
            self.start_date = start_date
        if flag_transactions is not None:
            self.flag_transactions = flag_transactions
        if transaction_status_scope is not None:
            self.transaction_status_scope = transaction_status_scope
        if only_cleansed is not None:
            self.only_cleansed = only_cleansed
        if aggregation_account_ids is not None:
            self.aggregation_account_ids = aggregation_account_ids
        if show_recurring_details is not None:
            self.show_recurring_details = show_recurring_details

    @property
    def currency_code(self):
        """Gets the currency_code of this RecurringTransactionAnalysisRequest.  # noqa: E501


        :return: The currency_code of this RecurringTransactionAnalysisRequest.  # noqa: E501
        :rtype: str
        """
        return self._currency_code

    @currency_code.setter
    def currency_code(self, currency_code):
        """Sets the currency_code of this RecurringTransactionAnalysisRequest.


        :param currency_code: The currency_code of this RecurringTransactionAnalysisRequest.  # noqa: E501
        :type: str
        """

        self._currency_code = currency_code

    @property
    def client_id(self):
        """Gets the client_id of this RecurringTransactionAnalysisRequest.  # noqa: E501


        :return: The client_id of this RecurringTransactionAnalysisRequest.  # noqa: E501
        :rtype: str
        """
        return self._client_id

    @client_id.setter
    def client_id(self, client_id):
        """Sets the client_id of this RecurringTransactionAnalysisRequest.


        :param client_id: The client_id of this RecurringTransactionAnalysisRequest.  # noqa: E501
        :type: str
        """

        self._client_id = client_id

    @property
    def scope(self):
        """Gets the scope of this RecurringTransactionAnalysisRequest.  # noqa: E501


        :return: The scope of this RecurringTransactionAnalysisRequest.  # noqa: E501
        :rtype: str
        """
        return self._scope

    @scope.setter
    def scope(self, scope):
        """Sets the scope of this RecurringTransactionAnalysisRequest.


        :param scope: The scope of this RecurringTransactionAnalysisRequest.  # noqa: E501
        :type: str
        """
        allowed_values = ["all", "external", "internal"]  # noqa: E501
        if (self._configuration.client_side_validation and
                scope not in allowed_values):
            raise ValueError(
                "Invalid value for `scope` ({0}), must be one of {1}"  # noqa: E501
                .format(scope, allowed_values)
            )

        self._scope = scope

    @property
    def end_date(self):
        """Gets the end_date of this RecurringTransactionAnalysisRequest.  # noqa: E501


        :return: The end_date of this RecurringTransactionAnalysisRequest.  # noqa: E501
        :rtype: date
        """
        return self._end_date

    @end_date.setter
    def end_date(self, end_date):
        """Sets the end_date of this RecurringTransactionAnalysisRequest.


        :param end_date: The end_date of this RecurringTransactionAnalysisRequest.  # noqa: E501
        :type: date
        """

        self._end_date = end_date

    @property
    def account_ids(self):
        """Gets the account_ids of this RecurringTransactionAnalysisRequest.  # noqa: E501


        :return: The account_ids of this RecurringTransactionAnalysisRequest.  # noqa: E501
        :rtype: list[str]
        """
        return self._account_ids

    @account_ids.setter
    def account_ids(self, account_ids):
        """Sets the account_ids of this RecurringTransactionAnalysisRequest.


        :param account_ids: The account_ids of this RecurringTransactionAnalysisRequest.  # noqa: E501
        :type: list[str]
        """

        self._account_ids = account_ids

    @property
    def currency_conversion(self):
        """Gets the currency_conversion of this RecurringTransactionAnalysisRequest.  # noqa: E501


        :return: The currency_conversion of this RecurringTransactionAnalysisRequest.  # noqa: E501
        :rtype: str
        """
        return self._currency_conversion

    @currency_conversion.setter
    def currency_conversion(self, currency_conversion):
        """Sets the currency_conversion of this RecurringTransactionAnalysisRequest.


        :param currency_conversion: The currency_conversion of this RecurringTransactionAnalysisRequest.  # noqa: E501
        :type: str
        """

        self._currency_conversion = currency_conversion

    @property
    def interval_deviation_threshold(self):
        """Gets the interval_deviation_threshold of this RecurringTransactionAnalysisRequest.  # noqa: E501


        :return: The interval_deviation_threshold of this RecurringTransactionAnalysisRequest.  # noqa: E501
        :rtype: int
        """
        return self._interval_deviation_threshold

    @interval_deviation_threshold.setter
    def interval_deviation_threshold(self, interval_deviation_threshold):
        """Sets the interval_deviation_threshold of this RecurringTransactionAnalysisRequest.


        :param interval_deviation_threshold: The interval_deviation_threshold of this RecurringTransactionAnalysisRequest.  # noqa: E501
        :type: int
        """
        if (self._configuration.client_side_validation and
                interval_deviation_threshold is not None and interval_deviation_threshold < 0):  # noqa: E501
            raise ValueError("Invalid value for `interval_deviation_threshold`, must be a value greater than or equal to `0`")  # noqa: E501

        self._interval_deviation_threshold = interval_deviation_threshold

    @property
    def amount_deviation_threshold(self):
        """Gets the amount_deviation_threshold of this RecurringTransactionAnalysisRequest.  # noqa: E501


        :return: The amount_deviation_threshold of this RecurringTransactionAnalysisRequest.  # noqa: E501
        :rtype: float
        """
        return self._amount_deviation_threshold

    @amount_deviation_threshold.setter
    def amount_deviation_threshold(self, amount_deviation_threshold):
        """Sets the amount_deviation_threshold of this RecurringTransactionAnalysisRequest.


        :param amount_deviation_threshold: The amount_deviation_threshold of this RecurringTransactionAnalysisRequest.  # noqa: E501
        :type: float
        """
        if (self._configuration.client_side_validation and
                amount_deviation_threshold is not None and amount_deviation_threshold > 1):  # noqa: E501
            raise ValueError("Invalid value for `amount_deviation_threshold`, must be a value less than or equal to `1`")  # noqa: E501
        if (self._configuration.client_side_validation and
                amount_deviation_threshold is not None and amount_deviation_threshold < 0):  # noqa: E501
            raise ValueError("Invalid value for `amount_deviation_threshold`, must be a value greater than or equal to `0`")  # noqa: E501

        self._amount_deviation_threshold = amount_deviation_threshold

    @property
    def analyze_transactions(self):
        """Gets the analyze_transactions of this RecurringTransactionAnalysisRequest.  # noqa: E501


        :return: The analyze_transactions of this RecurringTransactionAnalysisRequest.  # noqa: E501
        :rtype: bool
        """
        return self._analyze_transactions

    @analyze_transactions.setter
    def analyze_transactions(self, analyze_transactions):
        """Sets the analyze_transactions of this RecurringTransactionAnalysisRequest.


        :param analyze_transactions: The analyze_transactions of this RecurringTransactionAnalysisRequest.  # noqa: E501
        :type: bool
        """

        self._analyze_transactions = analyze_transactions

    @property
    def start_date(self):
        """Gets the start_date of this RecurringTransactionAnalysisRequest.  # noqa: E501


        :return: The start_date of this RecurringTransactionAnalysisRequest.  # noqa: E501
        :rtype: date
        """
        return self._start_date

    @start_date.setter
    def start_date(self, start_date):
        """Sets the start_date of this RecurringTransactionAnalysisRequest.


        :param start_date: The start_date of this RecurringTransactionAnalysisRequest.  # noqa: E501
        :type: date
        """

        self._start_date = start_date

    @property
    def flag_transactions(self):
        """Gets the flag_transactions of this RecurringTransactionAnalysisRequest.  # noqa: E501


        :return: The flag_transactions of this RecurringTransactionAnalysisRequest.  # noqa: E501
        :rtype: bool
        """
        return self._flag_transactions

    @flag_transactions.setter
    def flag_transactions(self, flag_transactions):
        """Sets the flag_transactions of this RecurringTransactionAnalysisRequest.


        :param flag_transactions: The flag_transactions of this RecurringTransactionAnalysisRequest.  # noqa: E501
        :type: bool
        """

        self._flag_transactions = flag_transactions

    @property
    def transaction_status_scope(self):
        """Gets the transaction_status_scope of this RecurringTransactionAnalysisRequest.  # noqa: E501


        :return: The transaction_status_scope of this RecurringTransactionAnalysisRequest.  # noqa: E501
        :rtype: list[str]
        """
        return self._transaction_status_scope

    @transaction_status_scope.setter
    def transaction_status_scope(self, transaction_status_scope):
        """Sets the transaction_status_scope of this RecurringTransactionAnalysisRequest.


        :param transaction_status_scope: The transaction_status_scope of this RecurringTransactionAnalysisRequest.  # noqa: E501
        :type: list[str]
        """

        self._transaction_status_scope = transaction_status_scope

    @property
    def only_cleansed(self):
        """Gets the only_cleansed of this RecurringTransactionAnalysisRequest.  # noqa: E501


        :return: The only_cleansed of this RecurringTransactionAnalysisRequest.  # noqa: E501
        :rtype: bool
        """
        return self._only_cleansed

    @only_cleansed.setter
    def only_cleansed(self, only_cleansed):
        """Sets the only_cleansed of this RecurringTransactionAnalysisRequest.


        :param only_cleansed: The only_cleansed of this RecurringTransactionAnalysisRequest.  # noqa: E501
        :type: bool
        """

        self._only_cleansed = only_cleansed

    @property
    def aggregation_account_ids(self):
        """Gets the aggregation_account_ids of this RecurringTransactionAnalysisRequest.  # noqa: E501


        :return: The aggregation_account_ids of this RecurringTransactionAnalysisRequest.  # noqa: E501
        :rtype: list[str]
        """
        return self._aggregation_account_ids

    @aggregation_account_ids.setter
    def aggregation_account_ids(self, aggregation_account_ids):
        """Sets the aggregation_account_ids of this RecurringTransactionAnalysisRequest.


        :param aggregation_account_ids: The aggregation_account_ids of this RecurringTransactionAnalysisRequest.  # noqa: E501
        :type: list[str]
        """

        self._aggregation_account_ids = aggregation_account_ids

    @property
    def show_recurring_details(self):
        """Gets the show_recurring_details of this RecurringTransactionAnalysisRequest.  # noqa: E501


        :return: The show_recurring_details of this RecurringTransactionAnalysisRequest.  # noqa: E501
        :rtype: bool
        """
        return self._show_recurring_details

    @show_recurring_details.setter
    def show_recurring_details(self, show_recurring_details):
        """Sets the show_recurring_details of this RecurringTransactionAnalysisRequest.


        :param show_recurring_details: The show_recurring_details of this RecurringTransactionAnalysisRequest.  # noqa: E501
        :type: bool
        """

        self._show_recurring_details = show_recurring_details

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(RecurringTransactionAnalysisRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RecurringTransactionAnalysisRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, RecurringTransactionAnalysisRequest):
            return True

        return self.to_dict() != other.to_dict()
